Rekomendowane odpowiedzi

Witam,

Napisałem prostego lispa, który uśrednia wybrane punkty. Chciałbym jednak aby działał przy użyciu funkcji "ssget" na dowolnej liczbie zaznaczonych punktów. Nie bardzo rozumiem jeszcze działanie tej funkcji więc proszę o pomoc. Wiem, że ilość zaznaczonych punktów mogę wyznaczyć za pomocą sslenght, nie wiem natomiast jak z tego zbioru wydobyć współrzędne, stworzyć listę i uśrednić współrzędne.

new1.lsp

srednia.lsp

Udostępnij tego posta


Odnośnik do posta
Udostępnij na innych stronach

Przygotowane przez Pana lispy to krok w dobrym kierunku.

Jakiej pomocy Pan oczekuje?

Działanie funkcji ssget sprowadza się do tego, że wybiera z rysunku obiekty po zadanych kryteriach.
Ma całkiem sporo trybów , które można przełączać. Funkcja może np pozwolić Użytkownikowi na wskazanie elementów albo wybrać automatycznie z całego rysunku.
W helpie ZWCADa jest artykuł na temat tej funkcji i jej trybów.

Współrzędne ze zbioru wskazań może Pan pobrać np w funkcji repeat  sprawdzając każdy element ssname.

Do pobrania współrzędnych może przydać się assoc 10

Udostępnij tego posta


Odnośnik do posta
Udostępnij na innych stronach

Dobrze kombinuję? Niestety zwraca mi wartość 0 0 0

(defun c:aaaaa()
(setq ss (ssget '((0 . "POINT"))))
(setq n (sslength ss))
(setq nss 0)
(princ "zaznaczonych:")
(princ n)
(setq pkt2 (list 0 0 0))
(while (< nss 1+n)
(setq ssnam (ssname ss nss))
(setq entgi (entget ssnam ))
(setq pkt0 (cdr (assoc 10 entgi)))
(setq pkt1 (list (car pkt0) (cadr pkt0) (caddr pkt0)))
(princ pkt1)
(setq pkt2 (list (+(car pkt2) (car pkt1)) (+(cadr pkt2) (cadr pkt1)) (+(caddr pkt2) (caddr pkt1))))
(princ pkt2)
(setq nss (1+ nss))
);end while
(princ pkt2)
); end func

Udostępnij tego posta


Odnośnik do posta
Udostępnij na innych stronach

Już wiem gdzie był błąd. Działa ;) Chyba zrozumiałem już mniej więcej o co chodzi.

(defun c:aaaaa()
(setq ss (ssget '((0 . "POINT"))))
(setq n (sslength ss))
(setq nss 0)
(princ "zaznaczonych:")
(princ n)
(setq pkt1 (list 0 0 0))
(while (< nss n);nss mniejsze poniewaz numeracja od zera
(setq ssnam (ssname ss nss)) ; ze zbioru wskazań ss pobiera element o indeksie nr, elementy liczone są od 0
(setq entgi (entget ssnam )); wybór opisu elementu jako listy dla podanej nazwy elementu
(setq pkt0 (cdr (assoc 10 entgi)));10 kod punktu wstawienia dla punktu dxf
(setq pkt1 (list (+(car pkt0) (car pkt1)) (+(cadr pkt0) (cadr pkt1)) (+(caddr pkt0) (caddr pkt1))))
(setq nss (+ nss 1))
);end while
(princ pkt1)
(setq pkt2 (list (/(car pkt1) n) (/(cadr pkt1) n) (/(caddr pkt1) n)))
(command "_erase" "_si" ss)
(command "_point" pkt2)
);end prog

Udostępnij tego posta


Odnośnik do posta
Udostępnij na innych stronach

Dlaczego podczas używania polecenia (command "_point" ....), pomimo tego, że punkt posiada konkretne współrzędne program snapuje punkty do obiektów? Da się to jakoś ominąć w lispie, aby nie musieć wyłączać snapowania na czas działania funkcji?

Udostępnij tego posta


Odnośnik do posta
Udostępnij na innych stronach

Niem jestem do końca pewien czy o to chodzi, ale proszę spróbować:

  • sprawdzić wartość zmiennej OSMODE i zapamiętać,
  • ustawić snapowanie tylko do punktów (chyba OSMODE=8) albo wyłączyć zupełnie,
  • wskazywać lub co potrzeba,
  • przywrócić zmienną OSMODE.

Udostępnij tego posta


Odnośnik do posta
Udostępnij na innych stronach

kiedyś miałem taki problem i załatwiłem to w ten sposób:

;===========================================================
(setvar "dimzin" 0)
(setvar "osnapcoord" 1)
;=============================================================

 

Udostępnij tego posta


Odnośnik do posta
Udostępnij na innych stronach

Jeśli chcesz dodać odpowiedź, zaloguj się lub zarejestruj nowe konto

Jedynie zarejestrowani użytkownicy mogą komentować zawartość tej strony.

Zarejestruj nowe konto

Załóż nowe konto. To bardzo proste!

Zarejestruj się

Zaloguj się

Posiadasz już konto? Zaloguj się poniżej.

Zaloguj się